using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using VaultClientNetLib.ClientService; 

namespace ConnectionTestMerck
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button ConnectButton;
		private System.Windows.Forms.TextBox serverBox;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox urlBox;
		private System.Windows.Forms.Button urlFetch;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.ConnectButton = new System.Windows.Forms.Button();
			this.serverBox = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.urlBox = new System.Windows.Forms.TextBox();
			this.urlFetch = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// ConnectButton
			// 
			this.ConnectButton.Location = new System.Drawing.Point(112, 32);
			this.ConnectButton.Name = "ConnectButton";
			this.ConnectButton.Size = new System.Drawing.Size(176, 23);
			this.ConnectButton.TabIndex = 0;
			this.ConnectButton.Text = "Connect to Vault Server";
			this.ConnectButton.Click += new System.EventHandler(this.ConnectButton_Click);
			// 
			// serverBox
			// 
			this.serverBox.Location = new System.Drawing.Point(112, 8);
			this.serverBox.Name = "serverBox";
			this.serverBox.Size = new System.Drawing.Size(232, 22);
			this.serverBox.TabIndex = 3;
			this.serverBox.Text = "vaultdemo.sourcegear.com";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(0, 8);
			this.label3.Name = "label3";
			this.label3.TabIndex = 12;
			this.label3.Text = "Vault Server";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(0, 60);
			this.label1.Name = "label1";
			this.label1.TabIndex = 15;
			this.label1.Text = "Internet URL";
			// 
			// urlBox
			// 
			this.urlBox.Location = new System.Drawing.Point(112, 60);
			this.urlBox.Name = "urlBox";
			this.urlBox.Size = new System.Drawing.Size(232, 22);
			this.urlBox.TabIndex = 14;
			this.urlBox.Text = "http://www.sourcegear.com/index.html";
			// 
			// urlFetch
			// 
			this.urlFetch.Location = new System.Drawing.Point(112, 84);
			this.urlFetch.Name = "urlFetch";
			this.urlFetch.Size = new System.Drawing.Size(176, 23);
			this.urlFetch.TabIndex = 13;
			this.urlFetch.Text = "Download Web Page";
			this.urlFetch.Click += new System.EventHandler(this.urlFetch_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.ClientSize = new System.Drawing.Size(398, 166);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.urlBox);
			this.Controls.Add(this.urlFetch);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.serverBox);
			this.Controls.Add(this.ConnectButton);
			this.Name = "Form1";
			this.Text = "Form1";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void ConnectButton_Click(object sender, System.EventArgs e)
		{
			string hostname ;
			
			hostname = this.serverBox.Text;
			
			if (hostname.StartsWith("http://") == false)
				hostname = "http://" + hostname;
			if (hostname.EndsWith("/VaultService") == false)
				hostname += "/VaultService/VaultService.asmx";
			
			VaultService _clientService = new VaultService();

			_clientService.Url = hostname;
			_clientService.Timeout = 1000 * 60 * 60 * 2;
			
			try
			{
				int[] _supportedServiceVersions = new int[] { 4 };
				/*if (this.textBox6.Text != "")
					_clientService.Proxy = new System.Net.WebProxy(this.textBox6.Text);
				*/
				int[] serviceSupportedVersions;
				serviceSupportedVersions = _clientService.ValidateServiceVersions(_supportedServiceVersions);
			
			}
			catch (Exception ex)
			{
				MessageBox.Show("Did not connect to the Vault Server. " + ex.Message);
				return;
			}

			MessageBox.Show("Successfully connected to the Vault Server.");
		}

		private void urlFetch_Click(object sender, System.EventArgs e)
		{
			try
			{
				HttpWebRequest wr =	(HttpWebRequest)WebRequest.Create(this.urlBox.Text);
				WebResponse s = wr.GetResponse();
				MessageBox.Show("Successfully downloaded " + s.ContentLength + " bytes from web server.");
			}
			catch (Exception ex)
			{
				MessageBox.Show("Did not connect to the web server. " + ex.Message);
				return;
			}
		}
	}
}
